// The code drives dual PCM3006 daughter card on VC5510 DSK
// The user should add dsk5510bslx.lib into the project
// Originally by Wei Li, liwei2000@gmail.com
// Modified by Michael Morrow for the VC5510 DSK and CCS v3.1


#include "dsk5510_dual3006cfg.h"
#include "dsk5510.h"
#include "dsk5510_led.h"
#include "csl.h"
#include "csl_irq.h"

#define FILE_INPUT		// uncomment when you want to use input from file
						// remember to include your input in the asm file
#define count 500		// used for file input.
						// change value to 


Uint32 input[2];  // mySample[0] = channel 1 and 2
					// mySample[1] = channel3 and 4 
Uint32 output[2]; // outSample[0] = channel 1 and 2
					// outSample[1] = channel 3 and 4 
Uint32 *outPtr;
Uint32 *inPtr;

int processed;
extern void filter();

#ifdef FILE_INPUT
extern Uint32 tv_inbuf[count*2];
extern Uint32 tv_outbuf[count*2];
#endif

void myHWI();

void main()
{
    // Initialize the board support library, must be called first
    DSK5510_init();
    
    // Switch McBSP0 and McBSP1 to EPI   
    DSK5510_rset(DSK5510_MISC, 0x03);// McBSP 0&1 to J3

    /* Start McBSP0 IIS slave */
    MCBSP_start(hMcbsp0, MCBSP_XMIT_START | MCBSP_RCV_START |
	MCBSP_SRGR_START | MCBSP_SRGR_FRAMESYNC, 220);
    
    /* Start McBSP1 IIS master */
    MCBSP_start(hMcbsp1, MCBSP_XMIT_START | MCBSP_RCV_START |
	MCBSP_SRGR_START | MCBSP_SRGR_FRAMESYNC, 220);
   
    IRQ_enable(IRQ_EVT_RINT0);
    
	processed = 0;

	inPtr = &input[0];
	outPtr = &output[0];

    return;
}

void HWI_RINT0()
{	
    input[0] = MCBSP_read32(hMcbsp0);
    input[1] = MCBSP_read32(hMcbsp1);
	
	#ifdef FILE_INPUT  // Use input from file buffer
	
	if (processed < count*2)
	{
		input[0] = tv_inbuf[processed];
		input[1] = tv_inbuf[processed+1];
	}
	
	#endif
	filter();
	
	#ifdef FILE_INPUT  // Save output to buffer

	if (processed < count*2)
	{
		tv_outbuf[processed++] = output[0];
		tv_outbuf[processed++] = output[1];
		
	}

	#endif


    MCBSP_write32(hMcbsp0, output[0]);
    MCBSP_write32(hMcbsp1, output[1]);
    		
}
