// The code drives dual PCM3006 daughter card on VC5510 DSK
// The user should add dsk5510bslx.lib into the project
// Originally by Wei Li, liwei2000@gmail.com
// Modified by Michael Morrow for the VC5510 DSK and CCS v3.1


#include "dsk5510_dual3006cfg.h"
#include "dsk5510.h"
#include "dsk5510_led.h"
#include "csl.h"
#include "csl_irq.h"

Uint32 input[2];  // mySample[0] = channel 1 and 2
					// mySample[1] = channel3 and 4 
Uint32 output[2]; // outSample[0] = channel 1 and 2
					// outSample[1] = channel 3 and 4 
Uint32 *outPtr;
Uint32 *inPtr;
extern void lab1();

void myHWI();

void main()
{
    // Initialize the board support library, must be called first
    DSK5510_init();
    
    // Switch McBSP0 and McBSP1 to EPI   
    DSK5510_rset(DSK5510_MISC, 0x03);// McBSP 0&1 to J3

    /* Start McBSP0 IIS slave */
    MCBSP_start(hMcbsp0, MCBSP_XMIT_START | MCBSP_RCV_START |
	MCBSP_SRGR_START | MCBSP_SRGR_FRAMESYNC, 220);
    
    /* Start McBSP1 IIS master */
    MCBSP_start(hMcbsp1, MCBSP_XMIT_START | MCBSP_RCV_START |
	MCBSP_SRGR_START | MCBSP_SRGR_FRAMESYNC, 220);
   
    IRQ_enable(IRQ_EVT_RINT0);
    
	inPtr = &input[0];
	//inSample34 = &input[1];
	outPtr = &output[0];
	//outSample34 = &output[1];

    return;
}

void HWI_RINT0()
{	
    input[0] = MCBSP_read32(hMcbsp0);
    input[1] = MCBSP_read32(hMcbsp1);
	
	lab1();
	
    MCBSP_write32(hMcbsp0, output[0]);
    MCBSP_write32(hMcbsp1, output[1]);
    		
}
